#!/system/bin/sh

echo 0 > /sys/fs/selinux/enforce
echo 0 > /sys/module/selinux/parameters/user_selinux_enforcing
setenforce 0

bb=/res/bin/busybox
chmod 755 $bb
alias bb=$bb
alias tb=/system/bin/toybox
PRIME=/data/PRIME-Kernel
HIDE_XPOSED=$(bb cat $PRIME/synapse/settings/hide_xposed_installer)
BAKDIR=$PRIME/xposed-backup
XPOSED_BACKUPS=`bb ls $BAKDIR|bb grep ".data.tar.gz"`
KERNEL_LOG=/data/media/0/prime-kernel.log

echo "Xposed-show: init" >> $KERNEL_LOG

if [ "$HIDE_XPOSED" -eq 1 ]; then
	XPOSED_APK=$(cat $PRIME/list/list_xposed_apks.txt)
	echo "Xposed-show: start" >> $KERNEL_LOG
	if [ "$XPOSED_BACKUPS" != "" ]; then
		for apps in $XPOSED_APK
		do
			test -z "$apps" && continue
			BACKUP_DATA=$BAKDIR/$apps.data.tar.gz
			#if [ -f $BACKUP_DATA ] && [ ! -e /data/data/$apps ]; then
			if [ -f $BACKUP_DATA ]; then
				bb rm -R /data/data/$apps
				echo "Xposed-show: $apps: start" >> $KERNEL_LOG
				bb mkdir /data/data/$apps && bb chmod 751 /data/data/$apps
				bb tar -xzf $BACKUP_DATA -C /data/data/$apps
				bb chmod 771 /data/data/$apps/conf
				bb chmod 771 /data/data/$apps/log
				bb chmod 771 /data/data/$apps/shared_prefs
				bb chmod 771 /data/data/$apps/no_backup
				bb chmod 664 /data/data/$apps/shared_prefs/*
				bb chmod 664 /data/data/$apps/no_backup/*
				bb chmod 664 /data/data/$apps/conf/*
				bb chmod 664 /data/data/$apps/log/*
				bb chmod 771 /data/data/$apps/shared_prefs
				bb chmod 771 /data/data/$apps/no_backup
				bb chmod 660 /data/data/$apps/shared_prefs/*
				bb chmod 660 /data/data/$apps/no_backup/*
				secon_orig="$(cat $PRIME/xposed-backup/$apps.secontexts)"
				if [ "$secon_orig" != "" ]; then
					secon="$secon_orig"
				else
					secon_sub=$(tb ls -Z /data/data|bb grep $apps|bb cut -d" " -f1)
					if [ "$secon_sub" != "" ]; then
						secon="$secon_sub"
					else
						secon="u:object_r:app_data_file:s0:c512,c768"
					fi
				fi
				chcon -R "$secon" /data/data/$apps
				echo "Xposed-show: $apps: end" >> $KERNEL_LOG
				break
			fi
		done
	fi
fi
