#!/system/bin/sh

SYNAPSE_LOADER_SRC=/data/PRIME-Kernel/bin/prime_loader2
SYNAPSE_LOADER_EXE=/data/local/tmp/synapse_loader.shx
SYNAPSE_LOADER_ACT=1
SYNAPSE_LOADER_LOG=/data/media/0/synapse_loader.log
LOADER_VER_PATH=/data/PRIME-Kernel/synapse_loader_ver
KERNEL_LOG=/data/media/0/prime-kernel.log
MODE=$1
is_root=0

BB=/res/bin/busybox
alias bb=$BB

rm $SYNAPSE_LOADER_LOG
rm $LOADER_VER_PATH

if [ "$MODE" != "install" ]; then
	echo synapseloader start >> $KERNEL_LOG
	echo - excecuted on $(date +"%Y-%d-%m %r") >> $KERNEL_LOG

	if [ -f /system/xbin/su ] || [ -f /sbin/su ]; then
		is_root=1
	fi

    echo ---------- su info ----------- >> $KERNEL_LOG
    id >> $KERNEL_LOG

	if [ -f $SYNAPSE_LOADER_SRC ] && [ $is_root -eq 1 ]; then
	    echo "- synapse_loader start: pase 0 - su detected" >> $SYNAPSE_LOADER_LOG
	    UNROOT_ONLY=`cat /data/PRIME-Kernel/synapse/settings/loader_unroot 2>/dev/null`
	    if [ "$UNROOT_ONLY" == "1" ]; then
	        echo "- synapse_loader: disabled, using unroot only option" >> $SYNAPSE_LOADER_LOG
	        SYNAPSE_LOADER_ACT=0
	    fi
	fi
fi

if [ -f $SYNAPSE_LOADER_SRC ]; then
	if [ "$MODE" != "install" ]; then
		echo "- synapse_loader: pase 1" >> $SYNAPSE_LOADER_LOG
	fi
	cat $SYNAPSE_LOADER_SRC | bb base64 -d > $SYNAPSE_LOADER_EXE
	if test $? -ne 0; then
		echo "- synapse_loader: Decryption Error! & Trying..." >> $SYNAPSE_LOADER_LOG
		cat $SYNAPSE_LOADER_SRC | bb base64 -d > $SYNAPSE_LOADER_EXE
	fi
	
	chmod 0755 $SYNAPSE_LOADER_EXE
	LOADER_VER=`echo $($SYNAPSE_LOADER_EXE version)`
	if test $? -ne 0; then
		echo "- synapse_loader: Excute Error!" >> $SYNAPSE_LOADER_LOG
		echo "- synapse_loader: exit!" >> $SYNAPSE_LOADER_LOG
		exit 1
	else
		echo "- synapse_loader: v$LOADER_VER" >> $SYNAPSE_LOADER_LOG
	fi

	if [[ "$LOADER_VER" < "4.0" ]]; then
		SYNAPSE_LOADER_SRC="synapseloader_notfound"
		echo 0 > $LOADER_VER_PATH
	else
		echo $LOADER_VER > $LOADER_VER_PATH
	fi
else
	rm -rf /data/PRIME-Kernel/bin
	rm -f $LOADER_VER_PATH
fi

if [ "$MODE" != "install" ]; then
	if [ -f $SYNAPSE_LOADER_SRC ] && [ $SYNAPSE_LOADER_ACT -eq 1 ]; then
		echo "- synapse_loader: pase 2 : start" >> $SYNAPSE_LOADER_LOG
		echo - excecuted on $(date +"%Y-%d-%m %r") >> $SYNAPSE_LOADER_LOG
		$SYNAPSE_LOADER_EXE
		echo "- synapse_loader: pase 2 : done" >> $SYNAPSE_LOADER_LOG
		echo - excecuted on $(date +"%Y-%d-%m %r") >> $SYNAPSE_LOADER_LOG
	fi
fi

rm -f $SYNAPSE_LOADER_EXE

